/*
 * 
 */
package InnoM.diagram.edit.parts;

import org.eclipse.draw2d.FigureUtilities;
import org.eclipse.draw2d.Label;
import org.eclipse.draw2d.geometry.Dimension;
import org.eclipse.draw2d.geometry.Rectangle;
import org.eclipse.gef.EditPart;
import org.eclipse.gef.EditPartFactory;
import org.eclipse.gef.tools.CellEditorLocator;
import org.eclipse.gmf.runtime.diagram.ui.editparts.ITextAwareEditPart;
import org.eclipse.gmf.runtime.draw2d.ui.figures.WrappingLabel;
import org.eclipse.gmf.runtime.notation.View;
import org.eclipse.jface.viewers.CellEditor;
import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.Text;

/**
 * @generated
 */
public class InnoMEditPartFactory implements EditPartFactory {

	/**
	 * @generated
	 */
	public EditPart createEditPart(EditPart context, Object model) {
		if (model instanceof View) {
			View view = (View) model;
			switch (InnoM.diagram.part.InnoMVisualIDRegistry.getVisualID(view)) {

			case InnoM.diagram.edit.parts.INNOEditPart.VISUAL_ID:
				return new InnoM.diagram.edit.parts.INNOEditPart(view);

			case InnoM.diagram.edit.parts.LeadershipEditPart.VISUAL_ID:
				return new InnoM.diagram.edit.parts.LeadershipEditPart(view);

			case InnoM.diagram.edit.parts.LeadershipNameEditPart.VISUAL_ID:
				return new InnoM.diagram.edit.parts.LeadershipNameEditPart(view);

			case InnoM.diagram.edit.parts.ProtagonistEditPart.VISUAL_ID:
				return new InnoM.diagram.edit.parts.ProtagonistEditPart(view);

			case InnoM.diagram.edit.parts.ProtagonistNamepProtagonistEditPart.VISUAL_ID:
				return new InnoM.diagram.edit.parts.ProtagonistNamepProtagonistEditPart(
						view);

			case InnoM.diagram.edit.parts.CEOEditPart.VISUAL_ID:
				return new InnoM.diagram.edit.parts.CEOEditPart(view);

			case InnoM.diagram.edit.parts.CEONameEditPart.VISUAL_ID:
				return new InnoM.diagram.edit.parts.CEONameEditPart(view);

			case InnoM.diagram.edit.parts.CEOFactorEditPart.VISUAL_ID:
				return new InnoM.diagram.edit.parts.CEOFactorEditPart(view);

			case InnoM.diagram.edit.parts.CEOFactorNameCeoCeoFactorEditPart.VISUAL_ID:
				return new InnoM.diagram.edit.parts.CEOFactorNameCeoCeoFactorEditPart(
						view);

			case InnoM.diagram.edit.parts.LeadershipLeadershipProtagonistCompartmentEditPart.VISUAL_ID:
				return new InnoM.diagram.edit.parts.LeadershipLeadershipProtagonistCompartmentEditPart(
						view);

			case InnoM.diagram.edit.parts.LeadershipLeadershipCeoCompartmentEditPart.VISUAL_ID:
				return new InnoM.diagram.edit.parts.LeadershipLeadershipCeoCompartmentEditPart(
						view);

			case InnoM.diagram.edit.parts.CEOCEOCeoFactorCompartmentEditPart.VISUAL_ID:
				return new InnoM.diagram.edit.parts.CEOCEOCeoFactorCompartmentEditPart(
						view);

			case InnoM.diagram.edit.parts.IsAAutoLinkEditPart.VISUAL_ID:
				return new InnoM.diagram.edit.parts.IsAAutoLinkEditPart(view);

			case InnoM.diagram.edit.parts.WrappingLabelEditPart.VISUAL_ID:
				return new InnoM.diagram.edit.parts.WrappingLabelEditPart(view);

			}
		}
		return createUnrecognizedEditPart(context, model);
	}

	/**
	 * @generated
	 */
	private EditPart createUnrecognizedEditPart(EditPart context, Object model) {
		// Handle creation of unrecognized child node EditParts here
		return null;
	}

	/**
	 * @generated
	 */
	public static CellEditorLocator getTextCellEditorLocator(
			ITextAwareEditPart source) {
		if (source.getFigure() instanceof WrappingLabel)
			return new TextCellEditorLocator((WrappingLabel) source.getFigure());
		else {
			return new LabelCellEditorLocator((Label) source.getFigure());
		}
	}

	/**
	 * @generated
	 */
	static private class TextCellEditorLocator implements CellEditorLocator {

		/**
		 * @generated
		 */
		private WrappingLabel wrapLabel;

		/**
		 * @generated
		 */
		public TextCellEditorLocator(WrappingLabel wrapLabel) {
			this.wrapLabel = wrapLabel;
		}

		/**
		 * @generated
		 */
		public WrappingLabel getWrapLabel() {
			return wrapLabel;
		}

		/**
		 * @generated
		 */
		public void relocate(CellEditor celleditor) {
			Text text = (Text) celleditor.getControl();
			Rectangle rect = getWrapLabel().getTextBounds().getCopy();
			getWrapLabel().translateToAbsolute(rect);
			if (!text.getFont().isDisposed()) {
				if (getWrapLabel().isTextWrapOn()
						&& getWrapLabel().getText().length() > 0) {
					rect.setSize(new Dimension(text.computeSize(rect.width,
							SWT.DEFAULT)));
				} else {
					int avr = FigureUtilities.getFontMetrics(text.getFont())
							.getAverageCharWidth();
					rect.setSize(new Dimension(text.computeSize(SWT.DEFAULT,
							SWT.DEFAULT)).expand(avr * 2, 0));
				}
			}
			if (!rect.equals(new Rectangle(text.getBounds()))) {
				text.setBounds(rect.x, rect.y, rect.width, rect.height);
			}
		}
	}

	/**
	 * @generated
	 */
	private static class LabelCellEditorLocator implements CellEditorLocator {

		/**
		 * @generated
		 */
		private Label label;

		/**
		 * @generated
		 */
		public LabelCellEditorLocator(Label label) {
			this.label = label;
		}

		/**
		 * @generated
		 */
		public Label getLabel() {
			return label;
		}

		/**
		 * @generated
		 */
		public void relocate(CellEditor celleditor) {
			Text text = (Text) celleditor.getControl();
			Rectangle rect = getLabel().getTextBounds().getCopy();
			getLabel().translateToAbsolute(rect);
			if (!text.getFont().isDisposed()) {
				int avr = FigureUtilities.getFontMetrics(text.getFont())
						.getAverageCharWidth();
				rect.setSize(new Dimension(text.computeSize(SWT.DEFAULT,
						SWT.DEFAULT)).expand(avr * 2, 0));
			}
			if (!rect.equals(new Rectangle(text.getBounds()))) {
				text.setBounds(rect.x, rect.y, rect.width, rect.height);
			}
		}
	}
}
