/*
 * 
 */
package InnoM.diagram.navigator;

import org.eclipse.core.runtime.IAdaptable;
import org.eclipse.gmf.runtime.common.ui.services.parser.CommonParserHint;
import org.eclipse.gmf.runtime.common.ui.services.parser.IParser;
import org.eclipse.gmf.runtime.common.ui.services.parser.ParserOptions;
import org.eclipse.gmf.runtime.emf.core.util.EObjectAdapter;
import org.eclipse.gmf.runtime.emf.type.core.IElementType;
import org.eclipse.gmf.runtime.notation.View;
import org.eclipse.jface.resource.ImageDescriptor;
import org.eclipse.jface.resource.ImageRegistry;
import org.eclipse.jface.viewers.ITreePathLabelProvider;
import org.eclipse.jface.viewers.LabelProvider;
import org.eclipse.jface.viewers.TreePath;
import org.eclipse.jface.viewers.ViewerLabel;
import org.eclipse.swt.graphics.Image;
import org.eclipse.ui.IMemento;
import org.eclipse.ui.navigator.ICommonContentExtensionSite;
import org.eclipse.ui.navigator.ICommonLabelProvider;

/**
 * @generated
 */
public class InnoMNavigatorLabelProvider extends LabelProvider implements
		ICommonLabelProvider, ITreePathLabelProvider {

	/**
	 * @generated
	 */
	static {
		InnoM.diagram.part.InnoMDiagramEditorPlugin
				.getInstance()
				.getImageRegistry()
				.put("Navigator?UnknownElement", ImageDescriptor.getMissingImageDescriptor()); //$NON-NLS-1$
		InnoM.diagram.part.InnoMDiagramEditorPlugin
				.getInstance()
				.getImageRegistry()
				.put("Navigator?ImageNotFound", ImageDescriptor.getMissingImageDescriptor()); //$NON-NLS-1$
	}

	/**
	 * @generated
	 */
	public void updateLabel(ViewerLabel label, TreePath elementPath) {
		Object element = elementPath.getLastSegment();
		if (element instanceof InnoM.diagram.navigator.InnoMNavigatorItem
				&& !isOwnView(((InnoM.diagram.navigator.InnoMNavigatorItem) element)
						.getView())) {
			return;
		}
		label.setText(getText(element));
		label.setImage(getImage(element));
	}

	/**
	 * @generated
	 */
	public Image getImage(Object element) {
		if (element instanceof InnoM.diagram.navigator.InnoMNavigatorGroup) {
			InnoM.diagram.navigator.InnoMNavigatorGroup group = (InnoM.diagram.navigator.InnoMNavigatorGroup) element;
			return InnoM.diagram.part.InnoMDiagramEditorPlugin.getInstance()
					.getBundledImage(group.getIcon());
		}

		if (element instanceof InnoM.diagram.navigator.InnoMNavigatorItem) {
			InnoM.diagram.navigator.InnoMNavigatorItem navigatorItem = (InnoM.diagram.navigator.InnoMNavigatorItem) element;
			if (!isOwnView(navigatorItem.getView())) {
				return super.getImage(element);
			}
			return getImage(navigatorItem.getView());
		}

		// Due to plugin.xml content will be called only for "own" views
		if (element instanceof IAdaptable) {
			View view = (View) ((IAdaptable) element).getAdapter(View.class);
			if (view != null && isOwnView(view)) {
				return getImage(view);
			}
		}

		return super.getImage(element);
	}

	/**
	 * @generated
	 */
	public Image getImage(View view) {
		switch (InnoM.diagram.part.InnoMVisualIDRegistry.getVisualID(view)) {
		case InnoM.diagram.edit.parts.INNOEditPart.VISUAL_ID:
			return getImage(
					"Navigator?Diagram?INNO?INNO", InnoM.diagram.providers.InnoMElementTypes.INNO_1000); //$NON-NLS-1$
		case InnoM.diagram.edit.parts.LeadershipEditPart.VISUAL_ID:
			return getImage(
					"Navigator?TopLevelNode?INNO?Leadership", InnoM.diagram.providers.InnoMElementTypes.Leadership_2001); //$NON-NLS-1$
		case InnoM.diagram.edit.parts.ProtagonistEditPart.VISUAL_ID:
			return getImage(
					"Navigator?Node?INNO?Protagonist", InnoM.diagram.providers.InnoMElementTypes.Protagonist_3001); //$NON-NLS-1$
		case InnoM.diagram.edit.parts.CEOFactorEditPart.VISUAL_ID:
			return getImage(
					"Navigator?Node?INNO?CEOFactor", InnoM.diagram.providers.InnoMElementTypes.CEOFactor_3003); //$NON-NLS-1$
		case InnoM.diagram.edit.parts.CEOEditPart.VISUAL_ID:
			return getImage(
					"Navigator?Node?INNO?CEO", InnoM.diagram.providers.InnoMElementTypes.CEO_3002); //$NON-NLS-1$
		case InnoM.diagram.edit.parts.IsAAutoLinkEditPart.VISUAL_ID:
			return getImage(
					"Navigator?Link?INNO?IsA?autoLink", InnoM.diagram.providers.InnoMElementTypes.IsAAutoLink_4001); //$NON-NLS-1$
		}
		return getImage("Navigator?UnknownElement", null); //$NON-NLS-1$
	}

	/**
	 * @generated
	 */
	private Image getImage(String key, IElementType elementType) {
		ImageRegistry imageRegistry = InnoM.diagram.part.InnoMDiagramEditorPlugin
				.getInstance().getImageRegistry();
		Image image = imageRegistry.get(key);
		if (image == null
				&& elementType != null
				&& InnoM.diagram.providers.InnoMElementTypes
						.isKnownElementType(elementType)) {
			image = InnoM.diagram.providers.InnoMElementTypes
					.getImage(elementType);
			imageRegistry.put(key, image);
		}

		if (image == null) {
			image = imageRegistry.get("Navigator?ImageNotFound"); //$NON-NLS-1$
			imageRegistry.put(key, image);
		}
		return image;
	}

	/**
	 * @generated
	 */
	public String getText(Object element) {
		if (element instanceof InnoM.diagram.navigator.InnoMNavigatorGroup) {
			InnoM.diagram.navigator.InnoMNavigatorGroup group = (InnoM.diagram.navigator.InnoMNavigatorGroup) element;
			return group.getGroupName();
		}

		if (element instanceof InnoM.diagram.navigator.InnoMNavigatorItem) {
			InnoM.diagram.navigator.InnoMNavigatorItem navigatorItem = (InnoM.diagram.navigator.InnoMNavigatorItem) element;
			if (!isOwnView(navigatorItem.getView())) {
				return null;
			}
			return getText(navigatorItem.getView());
		}

		// Due to plugin.xml content will be called only for "own" views
		if (element instanceof IAdaptable) {
			View view = (View) ((IAdaptable) element).getAdapter(View.class);
			if (view != null && isOwnView(view)) {
				return getText(view);
			}
		}

		return super.getText(element);
	}

	/**
	 * @generated
	 */
	public String getText(View view) {
		if (view.getElement() != null && view.getElement().eIsProxy()) {
			return getUnresolvedDomainElementProxyText(view);
		}
		switch (InnoM.diagram.part.InnoMVisualIDRegistry.getVisualID(view)) {
		case InnoM.diagram.edit.parts.INNOEditPart.VISUAL_ID:
			return getINNO_1000Text(view);
		case InnoM.diagram.edit.parts.LeadershipEditPart.VISUAL_ID:
			return getLeadership_2001Text(view);
		case InnoM.diagram.edit.parts.ProtagonistEditPart.VISUAL_ID:
			return getProtagonist_3001Text(view);
		case InnoM.diagram.edit.parts.CEOFactorEditPart.VISUAL_ID:
			return getCEOFactor_3003Text(view);
		case InnoM.diagram.edit.parts.CEOEditPart.VISUAL_ID:
			return getCEO_3002Text(view);
		case InnoM.diagram.edit.parts.IsAAutoLinkEditPart.VISUAL_ID:
			return getIsAAutoLink_4001Text(view);
		}
		return getUnknownElementText(view);
	}

	/**
	 * @generated
	 */
	private String getINNO_1000Text(View view) {
		return ""; //$NON-NLS-1$
	}

	/**
	 * @generated
	 */
	private String getLeadership_2001Text(View view) {
		IParser parser = InnoM.diagram.providers.InnoMParserProvider
				.getParser(
						InnoM.diagram.providers.InnoMElementTypes.Leadership_2001,
						view.getElement() != null ? view.getElement() : view,
						InnoM.diagram.part.InnoMVisualIDRegistry
								.getType(InnoM.diagram.edit.parts.LeadershipNameEditPart.VISUAL_ID));
		if (parser != null) {
			return parser.getPrintString(new EObjectAdapter(
					view.getElement() != null ? view.getElement() : view),
					ParserOptions.NONE.intValue());
		} else {
			InnoM.diagram.part.InnoMDiagramEditorPlugin.getInstance().logError(
					"Parser was not found for label " + 5004); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getProtagonist_3001Text(View view) {
		IParser parser = InnoM.diagram.providers.InnoMParserProvider
				.getParser(
						InnoM.diagram.providers.InnoMElementTypes.Protagonist_3001,
						view.getElement() != null ? view.getElement() : view,
						InnoM.diagram.part.InnoMVisualIDRegistry
								.getType(InnoM.diagram.edit.parts.ProtagonistNamepProtagonistEditPart.VISUAL_ID));
		if (parser != null) {
			return parser.getPrintString(new EObjectAdapter(
					view.getElement() != null ? view.getElement() : view),
					ParserOptions.NONE.intValue());
		} else {
			InnoM.diagram.part.InnoMDiagramEditorPlugin.getInstance().logError(
					"Parser was not found for label " + 5001); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getCEOFactor_3003Text(View view) {
		IParser parser = InnoM.diagram.providers.InnoMParserProvider
				.getParser(
						InnoM.diagram.providers.InnoMElementTypes.CEOFactor_3003,
						view.getElement() != null ? view.getElement() : view,
						InnoM.diagram.part.InnoMVisualIDRegistry
								.getType(InnoM.diagram.edit.parts.CEOFactorNameCeoCeoFactorEditPart.VISUAL_ID));
		if (parser != null) {
			return parser.getPrintString(new EObjectAdapter(
					view.getElement() != null ? view.getElement() : view),
					ParserOptions.NONE.intValue());
		} else {
			InnoM.diagram.part.InnoMDiagramEditorPlugin.getInstance().logError(
					"Parser was not found for label " + 5002); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getCEO_3002Text(View view) {
		IParser parser = InnoM.diagram.providers.InnoMParserProvider
				.getParser(
						InnoM.diagram.providers.InnoMElementTypes.CEO_3002,
						view.getElement() != null ? view.getElement() : view,
						InnoM.diagram.part.InnoMVisualIDRegistry
								.getType(InnoM.diagram.edit.parts.CEONameEditPart.VISUAL_ID));
		if (parser != null) {
			return parser.getPrintString(new EObjectAdapter(
					view.getElement() != null ? view.getElement() : view),
					ParserOptions.NONE.intValue());
		} else {
			InnoM.diagram.part.InnoMDiagramEditorPlugin.getInstance().logError(
					"Parser was not found for label " + 5003); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getIsAAutoLink_4001Text(View view) {
		IParser parser = InnoM.diagram.providers.InnoMParserProvider.getParser(
				InnoM.diagram.providers.InnoMElementTypes.IsAAutoLink_4001,
				view.getElement() != null ? view.getElement() : view,
				CommonParserHint.DESCRIPTION);
		if (parser != null) {
			return parser.getPrintString(new EObjectAdapter(
					view.getElement() != null ? view.getElement() : view),
					ParserOptions.NONE.intValue());
		} else {
			InnoM.diagram.part.InnoMDiagramEditorPlugin.getInstance().logError(
					"Parser was not found for label " + 6001); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getUnknownElementText(View view) {
		return "<UnknownElement Visual_ID = " + view.getType() + ">"; //$NON-NLS-1$  //$NON-NLS-2$
	}

	/**
	 * @generated
	 */
	private String getUnresolvedDomainElementProxyText(View view) {
		return "<Unresolved domain element Visual_ID = " + view.getType() + ">"; //$NON-NLS-1$  //$NON-NLS-2$
	}

	/**
	 * @generated
	 */
	public void init(ICommonContentExtensionSite aConfig) {
	}

	/**
	 * @generated
	 */
	public void restoreState(IMemento aMemento) {
	}

	/**
	 * @generated
	 */
	public void saveState(IMemento aMemento) {
	}

	/**
	 * @generated
	 */
	public String getDescription(Object anElement) {
		return null;
	}

	/**
	 * @generated
	 */
	private boolean isOwnView(View view) {
		return InnoM.diagram.edit.parts.INNOEditPart.MODEL_ID
				.equals(InnoM.diagram.part.InnoMVisualIDRegistry
						.getModelID(view));
	}

}
