/*
 * 
 */
package InnoM.diagram.providers;

import java.util.HashSet;
import java.util.IdentityHashMap;
import java.util.Map;
import java.util.Set;

import org.eclipse.core.runtime.IAdaptable;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EClassifier;
import org.eclipse.emf.ecore.ENamedElement;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.gmf.runtime.emf.type.core.ElementTypeRegistry;
import org.eclipse.gmf.runtime.emf.type.core.IElementType;
import org.eclipse.jface.resource.ImageDescriptor;
import org.eclipse.jface.resource.ImageRegistry;
import org.eclipse.swt.graphics.Image;

/**
 * @generated
 */
public class InnoMElementTypes {

	/**
	 * @generated
	 */
	private InnoMElementTypes() {
	}

	/**
	 * @generated
	 */
	private static Map<IElementType, ENamedElement> elements;

	/**
	 * @generated
	 */
	private static ImageRegistry imageRegistry;

	/**
	 * @generated
	 */
	private static Set<IElementType> KNOWN_ELEMENT_TYPES;

	/**
	 * @generated
	 */
	public static final IElementType INNO_1000 = getElementType("MExampleEncodingProblem.diagram.INNO_1000"); //$NON-NLS-1$
	/**
	 * @generated
	 */
	public static final IElementType Leadership_2001 = getElementType("MExampleEncodingProblem.diagram.Leadership_2001"); //$NON-NLS-1$
	/**
	 * @generated
	 */
	public static final IElementType Protagonist_3001 = getElementType("MExampleEncodingProblem.diagram.Protagonist_3001"); //$NON-NLS-1$
	/**
	 * @generated
	 */
	public static final IElementType CEO_3002 = getElementType("MExampleEncodingProblem.diagram.CEO_3002"); //$NON-NLS-1$
	/**
	 * @generated
	 */
	public static final IElementType CEOFactor_3003 = getElementType("MExampleEncodingProblem.diagram.CEOFactor_3003"); //$NON-NLS-1$
	/**
	 * @generated
	 */
	public static final IElementType IsAAutoLink_4001 = getElementType("MExampleEncodingProblem.diagram.IsAAutoLink_4001"); //$NON-NLS-1$

	/**
	 * @generated
	 */
	private static ImageRegistry getImageRegistry() {
		if (imageRegistry == null) {
			imageRegistry = new ImageRegistry();
		}
		return imageRegistry;
	}

	/**
	 * @generated
	 */
	private static String getImageRegistryKey(ENamedElement element) {
		return element.getName();
	}

	/**
	 * @generated
	 */
	private static ImageDescriptor getProvidedImageDescriptor(
			ENamedElement element) {
		if (element instanceof EStructuralFeature) {
			EStructuralFeature feature = ((EStructuralFeature) element);
			EClass eContainingClass = feature.getEContainingClass();
			EClassifier eType = feature.getEType();
			if (eContainingClass != null && !eContainingClass.isAbstract()) {
				element = eContainingClass;
			} else if (eType instanceof EClass
					&& !((EClass) eType).isAbstract()) {
				element = eType;
			}
		}
		if (element instanceof EClass) {
			EClass eClass = (EClass) element;
			if (!eClass.isAbstract()) {
				return InnoM.diagram.part.InnoMDiagramEditorPlugin
						.getInstance().getItemImageDescriptor(
								eClass.getEPackage().getEFactoryInstance()
										.create(eClass));
			}
		}
		// TODO : support structural features
		return null;
	}

	/**
	 * @generated
	 */
	public static ImageDescriptor getImageDescriptor(ENamedElement element) {
		String key = getImageRegistryKey(element);
		ImageDescriptor imageDescriptor = getImageRegistry().getDescriptor(key);
		if (imageDescriptor == null) {
			imageDescriptor = getProvidedImageDescriptor(element);
			if (imageDescriptor == null) {
				imageDescriptor = ImageDescriptor.getMissingImageDescriptor();
			}
			getImageRegistry().put(key, imageDescriptor);
		}
		return imageDescriptor;
	}

	/**
	 * @generated
	 */
	public static Image getImage(ENamedElement element) {
		String key = getImageRegistryKey(element);
		Image image = getImageRegistry().get(key);
		if (image == null) {
			ImageDescriptor imageDescriptor = getProvidedImageDescriptor(element);
			if (imageDescriptor == null) {
				imageDescriptor = ImageDescriptor.getMissingImageDescriptor();
			}
			getImageRegistry().put(key, imageDescriptor);
			image = getImageRegistry().get(key);
		}
		return image;
	}

	/**
	 * @generated
	 */
	public static ImageDescriptor getImageDescriptor(IAdaptable hint) {
		ENamedElement element = getElement(hint);
		if (element == null) {
			return null;
		}
		return getImageDescriptor(element);
	}

	/**
	 * @generated
	 */
	public static Image getImage(IAdaptable hint) {
		ENamedElement element = getElement(hint);
		if (element == null) {
			return null;
		}
		return getImage(element);
	}

	/**
	 * Returns 'type' of the ecore object associated with the hint.
	 * 
	 * @generated
	 */
	public static ENamedElement getElement(IAdaptable hint) {
		Object type = hint.getAdapter(IElementType.class);
		if (elements == null) {
			elements = new IdentityHashMap<IElementType, ENamedElement>();

			elements.put(INNO_1000, InnoM.InnoMPackage.eINSTANCE.getINNO());

			elements.put(Leadership_2001,
					InnoM.InnoMPackage.eINSTANCE.getLeadership());

			elements.put(Protagonist_3001,
					InnoM.InnoMPackage.eINSTANCE.getProtagonist());

			elements.put(CEO_3002, InnoM.InnoMPackage.eINSTANCE.getCEO());

			elements.put(CEOFactor_3003,
					InnoM.InnoMPackage.eINSTANCE.getCEOFactor());

			elements.put(IsAAutoLink_4001,
					InnoM.InnoMPackage.eINSTANCE.getIsA_AutoLink());
		}
		return (ENamedElement) elements.get(type);
	}

	/**
	 * @generated
	 */
	private static IElementType getElementType(String id) {
		return ElementTypeRegistry.getInstance().getType(id);
	}

	/**
	 * @generated
	 */
	public static boolean isKnownElementType(IElementType elementType) {
		if (KNOWN_ELEMENT_TYPES == null) {
			KNOWN_ELEMENT_TYPES = new HashSet<IElementType>();
			KNOWN_ELEMENT_TYPES.add(INNO_1000);
			KNOWN_ELEMENT_TYPES.add(Leadership_2001);
			KNOWN_ELEMENT_TYPES.add(Protagonist_3001);
			KNOWN_ELEMENT_TYPES.add(CEO_3002);
			KNOWN_ELEMENT_TYPES.add(CEOFactor_3003);
			KNOWN_ELEMENT_TYPES.add(IsAAutoLink_4001);
		}
		return KNOWN_ELEMENT_TYPES.contains(elementType);
	}

	/**
	 * @generated
	 */
	public static IElementType getElementType(int visualID) {
		switch (visualID) {
		case InnoM.diagram.edit.parts.INNOEditPart.VISUAL_ID:
			return INNO_1000;
		case InnoM.diagram.edit.parts.LeadershipEditPart.VISUAL_ID:
			return Leadership_2001;
		case InnoM.diagram.edit.parts.ProtagonistEditPart.VISUAL_ID:
			return Protagonist_3001;
		case InnoM.diagram.edit.parts.CEOEditPart.VISUAL_ID:
			return CEO_3002;
		case InnoM.diagram.edit.parts.CEOFactorEditPart.VISUAL_ID:
			return CEOFactor_3003;
		case InnoM.diagram.edit.parts.IsAAutoLinkEditPart.VISUAL_ID:
			return IsAAutoLink_4001;
		}
		return null;
	}

}
