/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package Inno;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EEnum;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;

/**
 * <!-- begin-user-doc -->
 * The <b>Package</b> for the model.
 * It contains accessors for the meta objects to represent
 * <ul>
 *   <li>each class,</li>
 *   <li>each feature of each class,</li>
 *   <li>each enum,</li>
 *   <li>and each data type</li>
 * </ul>
 * <!-- end-user-doc -->
 * @see Inno.InnoFactory
 * @model kind="package"
 * @generated
 */
public interface InnoPackage extends EPackage
{
  /**
   * The package name.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  String eNAME = "Inno";

  /**
   * The package namespace URI.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  String eNS_URI = "INNO";

  /**
   * The package namespace name.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  String eNS_PREFIX = "";

  /**
   * The singleton instance of the package.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  InnoPackage eINSTANCE = Inno.impl.InnoPackageImpl.init();

  /**
   * The meta object id for the '{@link Inno.impl.INNOImpl <em>INNO</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see Inno.impl.INNOImpl
   * @see Inno.impl.InnoPackageImpl#getINNO()
   * @generated
   */
  int INNO = 0;

  /**
   * The feature id for the '<em><b>Leadership</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int INNO__LEADERSHIP = 0;

  /**
   * The number of structural features of the '<em>INNO</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int INNO_FEATURE_COUNT = 1;

  /**
   * The meta object id for the '{@link Inno.impl.IsAImpl <em>Is A</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see Inno.impl.IsAImpl
   * @see Inno.impl.InnoPackageImpl#getIsA()
   * @generated
   */
  int IS_A = 1;

  /**
   * The feature id for the '<em><b>Auto Link</b></em>' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int IS_A__AUTO_LINK = 0;

  /**
   * The number of structural features of the '<em>Is A</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int IS_A_FEATURE_COUNT = 1;

  /**
   * The meta object id for the '{@link Inno.impl.FactorImpl <em>Factor</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see Inno.impl.FactorImpl
   * @see Inno.impl.InnoPackageImpl#getFactor()
   * @generated
   */
  int FACTOR = 2;

  /**
   * The feature id for the '<em><b>Date</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int FACTOR__DATE = 0;

  /**
   * The feature id for the '<em><b>Rationale</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int FACTOR__RATIONALE = 1;

  /**
   * The feature id for the '<em><b>Sources Of Information</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int FACTOR__SOURCES_OF_INFORMATION = 2;

  /**
   * The number of structural features of the '<em>Factor</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int FACTOR_FEATURE_COUNT = 3;

  /**
   * The meta object id for the '{@link Inno.impl.LeadershipImpl <em>Leadership</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see Inno.impl.LeadershipImpl
   * @see Inno.impl.InnoPackageImpl#getLeadership()
   * @generated
   */
  int LEADERSHIP = 3;

  /**
   * The feature id for the '<em><b>Auto Link</b></em>' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int LEADERSHIP__AUTO_LINK = IS_A__AUTO_LINK;

  /**
   * The feature id for the '<em><b>Name</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int LEADERSHIP__NAME = IS_A_FEATURE_COUNT + 0;

  /**
   * The feature id for the '<em><b>Protagonist</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int LEADERSHIP__PROTAGONIST = IS_A_FEATURE_COUNT + 1;

  /**
   * The feature id for the '<em><b>Ceo</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int LEADERSHIP__CEO = IS_A_FEATURE_COUNT + 2;

  /**
   * The number of structural features of the '<em>Leadership</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int LEADERSHIP_FEATURE_COUNT = IS_A_FEATURE_COUNT + 3;

  /**
   * The meta object id for the '{@link Inno.impl.ProtagonistImpl <em>Protagonist</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see Inno.impl.ProtagonistImpl
   * @see Inno.impl.InnoPackageImpl#getProtagonist()
   * @generated
   */
  int PROTAGONIST = 4;

  /**
   * The feature id for the '<em><b>Namep</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int PROTAGONIST__NAMEP = 0;

  /**
   * The feature id for the '<em><b>Protagonist</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int PROTAGONIST__PROTAGONIST = 1;

  /**
   * The number of structural features of the '<em>Protagonist</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int PROTAGONIST_FEATURE_COUNT = 2;

  /**
   * The meta object id for the '{@link Inno.impl.CEOImpl <em>CEO</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see Inno.impl.CEOImpl
   * @see Inno.impl.InnoPackageImpl#getCEO()
   * @generated
   */
  int CEO = 5;

  /**
   * The feature id for the '<em><b>Name</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int CEO__NAME = 0;

  /**
   * The feature id for the '<em><b>Ceo Factor</b></em>' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int CEO__CEO_FACTOR = 1;

  /**
   * The number of structural features of the '<em>CEO</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int CEO_FEATURE_COUNT = 2;

  /**
   * The meta object id for the '{@link Inno.impl.CEOFactorImpl <em>CEO Factor</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see Inno.impl.CEOFactorImpl
   * @see Inno.impl.InnoPackageImpl#getCEOFactor()
   * @generated
   */
  int CEO_FACTOR = 6;

  /**
   * The feature id for the '<em><b>Date</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int CEO_FACTOR__DATE = FACTOR__DATE;

  /**
   * The feature id for the '<em><b>Rationale</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int CEO_FACTOR__RATIONALE = FACTOR__RATIONALE;

  /**
   * The feature id for the '<em><b>Sources Of Information</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int CEO_FACTOR__SOURCES_OF_INFORMATION = FACTOR__SOURCES_OF_INFORMATION;

  /**
   * The feature id for the '<em><b>Name Ceo</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int CEO_FACTOR__NAME_CEO = FACTOR_FEATURE_COUNT + 0;

  /**
   * The feature id for the '<em><b>Ceo Factor</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int CEO_FACTOR__CEO_FACTOR = FACTOR_FEATURE_COUNT + 1;

  /**
   * The number of structural features of the '<em>CEO Factor</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int CEO_FACTOR_FEATURE_COUNT = FACTOR_FEATURE_COUNT + 2;

  /**
   * The meta object id for the '{@link Inno.Protagonists <em>Protagonists</em>}' enum.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see Inno.Protagonists
   * @see Inno.impl.InnoPackageImpl#getProtagonists()
   * @generated
   */
  int PROTAGONISTS = 7;

  /**
   * The meta object id for the '{@link Inno.CEOFactors <em>CEO Factors</em>}' enum.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see Inno.CEOFactors
   * @see Inno.impl.InnoPackageImpl#getCEOFactors()
   * @generated
   */
  int CEO_FACTORS = 8;


  /**
   * Returns the meta object for class '{@link Inno.INNO <em>INNO</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>INNO</em>'.
   * @see Inno.INNO
   * @generated
   */
  EClass getINNO();

  /**
   * Returns the meta object for the containment reference '{@link Inno.INNO#getLeadership <em>Leadership</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference '<em>Leadership</em>'.
   * @see Inno.INNO#getLeadership()
   * @see #getINNO()
   * @generated
   */
  EReference getINNO_Leadership();

  /**
   * Returns the meta object for class '{@link Inno.IsA <em>Is A</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Is A</em>'.
   * @see Inno.IsA
   * @generated
   */
  EClass getIsA();

  /**
   * Returns the meta object for the reference list '{@link Inno.IsA#getAutoLink <em>Auto Link</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the reference list '<em>Auto Link</em>'.
   * @see Inno.IsA#getAutoLink()
   * @see #getIsA()
   * @generated
   */
  EReference getIsA_AutoLink();

  /**
   * Returns the meta object for class '{@link Inno.Factor <em>Factor</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Factor</em>'.
   * @see Inno.Factor
   * @generated
   */
  EClass getFactor();

  /**
   * Returns the meta object for the attribute '{@link Inno.Factor#getDate <em>Date</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Date</em>'.
   * @see Inno.Factor#getDate()
   * @see #getFactor()
   * @generated
   */
  EAttribute getFactor_Date();

  /**
   * Returns the meta object for the attribute '{@link Inno.Factor#getRationale <em>Rationale</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Rationale</em>'.
   * @see Inno.Factor#getRationale()
   * @see #getFactor()
   * @generated
   */
  EAttribute getFactor_Rationale();

  /**
   * Returns the meta object for the attribute '{@link Inno.Factor#getSourcesOfInformation <em>Sources Of Information</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Sources Of Information</em>'.
   * @see Inno.Factor#getSourcesOfInformation()
   * @see #getFactor()
   * @generated
   */
  EAttribute getFactor_SourcesOfInformation();

  /**
   * Returns the meta object for class '{@link Inno.Leadership <em>Leadership</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Leadership</em>'.
   * @see Inno.Leadership
   * @generated
   */
  EClass getLeadership();

  /**
   * Returns the meta object for the attribute '{@link Inno.Leadership#getName <em>Name</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Name</em>'.
   * @see Inno.Leadership#getName()
   * @see #getLeadership()
   * @generated
   */
  EAttribute getLeadership_Name();

  /**
   * Returns the meta object for the containment reference '{@link Inno.Leadership#getProtagonist <em>Protagonist</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference '<em>Protagonist</em>'.
   * @see Inno.Leadership#getProtagonist()
   * @see #getLeadership()
   * @generated
   */
  EReference getLeadership_Protagonist();

  /**
   * Returns the meta object for the containment reference '{@link Inno.Leadership#getCeo <em>Ceo</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference '<em>Ceo</em>'.
   * @see Inno.Leadership#getCeo()
   * @see #getLeadership()
   * @generated
   */
  EReference getLeadership_Ceo();

  /**
   * Returns the meta object for class '{@link Inno.Protagonist <em>Protagonist</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Protagonist</em>'.
   * @see Inno.Protagonist
   * @generated
   */
  EClass getProtagonist();

  /**
   * Returns the meta object for the attribute '{@link Inno.Protagonist#getNamep <em>Namep</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Namep</em>'.
   * @see Inno.Protagonist#getNamep()
   * @see #getProtagonist()
   * @generated
   */
  EAttribute getProtagonist_Namep();

  /**
   * Returns the meta object for the attribute '{@link Inno.Protagonist#getProtagonist <em>Protagonist</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Protagonist</em>'.
   * @see Inno.Protagonist#getProtagonist()
   * @see #getProtagonist()
   * @generated
   */
  EAttribute getProtagonist_Protagonist();

  /**
   * Returns the meta object for class '{@link Inno.CEO <em>CEO</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>CEO</em>'.
   * @see Inno.CEO
   * @generated
   */
  EClass getCEO();

  /**
   * Returns the meta object for the attribute '{@link Inno.CEO#getName <em>Name</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Name</em>'.
   * @see Inno.CEO#getName()
   * @see #getCEO()
   * @generated
   */
  EAttribute getCEO_Name();

  /**
   * Returns the meta object for the containment reference list '{@link Inno.CEO#getCeoFactor <em>Ceo Factor</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference list '<em>Ceo Factor</em>'.
   * @see Inno.CEO#getCeoFactor()
   * @see #getCEO()
   * @generated
   */
  EReference getCEO_CeoFactor();

  /**
   * Returns the meta object for class '{@link Inno.CEOFactor <em>CEO Factor</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>CEO Factor</em>'.
   * @see Inno.CEOFactor
   * @generated
   */
  EClass getCEOFactor();

  /**
   * Returns the meta object for the attribute '{@link Inno.CEOFactor#getNameCeo <em>Name Ceo</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Name Ceo</em>'.
   * @see Inno.CEOFactor#getNameCeo()
   * @see #getCEOFactor()
   * @generated
   */
  EAttribute getCEOFactor_NameCeo();

  /**
   * Returns the meta object for the attribute '{@link Inno.CEOFactor#getCeoFactor <em>Ceo Factor</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Ceo Factor</em>'.
   * @see Inno.CEOFactor#getCeoFactor()
   * @see #getCEOFactor()
   * @generated
   */
  EAttribute getCEOFactor_CeoFactor();

  /**
   * Returns the meta object for enum '{@link Inno.Protagonists <em>Protagonists</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for enum '<em>Protagonists</em>'.
   * @see Inno.Protagonists
   * @generated
   */
  EEnum getProtagonists();

  /**
   * Returns the meta object for enum '{@link Inno.CEOFactors <em>CEO Factors</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for enum '<em>CEO Factors</em>'.
   * @see Inno.CEOFactors
   * @generated
   */
  EEnum getCEOFactors();

  /**
   * Returns the factory that creates the instances of the model.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the factory that creates the instances of the model.
   * @generated
   */
  InnoFactory getInnoFactory();

  /**
   * <!-- begin-user-doc -->
   * Defines literals for the meta objects that represent
   * <ul>
   *   <li>each class,</li>
   *   <li>each feature of each class,</li>
   *   <li>each enum,</li>
   *   <li>and each data type</li>
   * </ul>
   * <!-- end-user-doc -->
   * @generated
   */
  interface Literals
  {
    /**
     * The meta object literal for the '{@link Inno.impl.INNOImpl <em>INNO</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see Inno.impl.INNOImpl
     * @see Inno.impl.InnoPackageImpl#getINNO()
     * @generated
     */
    EClass INNO = eINSTANCE.getINNO();

    /**
     * The meta object literal for the '<em><b>Leadership</b></em>' containment reference feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference INNO__LEADERSHIP = eINSTANCE.getINNO_Leadership();

    /**
     * The meta object literal for the '{@link Inno.impl.IsAImpl <em>Is A</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see Inno.impl.IsAImpl
     * @see Inno.impl.InnoPackageImpl#getIsA()
     * @generated
     */
    EClass IS_A = eINSTANCE.getIsA();

    /**
     * The meta object literal for the '<em><b>Auto Link</b></em>' reference list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference IS_A__AUTO_LINK = eINSTANCE.getIsA_AutoLink();

    /**
     * The meta object literal for the '{@link Inno.impl.FactorImpl <em>Factor</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see Inno.impl.FactorImpl
     * @see Inno.impl.InnoPackageImpl#getFactor()
     * @generated
     */
    EClass FACTOR = eINSTANCE.getFactor();

    /**
     * The meta object literal for the '<em><b>Date</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute FACTOR__DATE = eINSTANCE.getFactor_Date();

    /**
     * The meta object literal for the '<em><b>Rationale</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute FACTOR__RATIONALE = eINSTANCE.getFactor_Rationale();

    /**
     * The meta object literal for the '<em><b>Sources Of Information</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute FACTOR__SOURCES_OF_INFORMATION = eINSTANCE.getFactor_SourcesOfInformation();

    /**
     * The meta object literal for the '{@link Inno.impl.LeadershipImpl <em>Leadership</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see Inno.impl.LeadershipImpl
     * @see Inno.impl.InnoPackageImpl#getLeadership()
     * @generated
     */
    EClass LEADERSHIP = eINSTANCE.getLeadership();

    /**
     * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute LEADERSHIP__NAME = eINSTANCE.getLeadership_Name();

    /**
     * The meta object literal for the '<em><b>Protagonist</b></em>' containment reference feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference LEADERSHIP__PROTAGONIST = eINSTANCE.getLeadership_Protagonist();

    /**
     * The meta object literal for the '<em><b>Ceo</b></em>' containment reference feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference LEADERSHIP__CEO = eINSTANCE.getLeadership_Ceo();

    /**
     * The meta object literal for the '{@link Inno.impl.ProtagonistImpl <em>Protagonist</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see Inno.impl.ProtagonistImpl
     * @see Inno.impl.InnoPackageImpl#getProtagonist()
     * @generated
     */
    EClass PROTAGONIST = eINSTANCE.getProtagonist();

    /**
     * The meta object literal for the '<em><b>Namep</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute PROTAGONIST__NAMEP = eINSTANCE.getProtagonist_Namep();

    /**
     * The meta object literal for the '<em><b>Protagonist</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute PROTAGONIST__PROTAGONIST = eINSTANCE.getProtagonist_Protagonist();

    /**
     * The meta object literal for the '{@link Inno.impl.CEOImpl <em>CEO</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see Inno.impl.CEOImpl
     * @see Inno.impl.InnoPackageImpl#getCEO()
     * @generated
     */
    EClass CEO = eINSTANCE.getCEO();

    /**
     * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute CEO__NAME = eINSTANCE.getCEO_Name();

    /**
     * The meta object literal for the '<em><b>Ceo Factor</b></em>' containment reference list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference CEO__CEO_FACTOR = eINSTANCE.getCEO_CeoFactor();

    /**
     * The meta object literal for the '{@link Inno.impl.CEOFactorImpl <em>CEO Factor</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see Inno.impl.CEOFactorImpl
     * @see Inno.impl.InnoPackageImpl#getCEOFactor()
     * @generated
     */
    EClass CEO_FACTOR = eINSTANCE.getCEOFactor();

    /**
     * The meta object literal for the '<em><b>Name Ceo</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute CEO_FACTOR__NAME_CEO = eINSTANCE.getCEOFactor_NameCeo();

    /**
     * The meta object literal for the '<em><b>Ceo Factor</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute CEO_FACTOR__CEO_FACTOR = eINSTANCE.getCEOFactor_CeoFactor();

    /**
     * The meta object literal for the '{@link Inno.Protagonists <em>Protagonists</em>}' enum.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see Inno.Protagonists
     * @see Inno.impl.InnoPackageImpl#getProtagonists()
     * @generated
     */
    EEnum PROTAGONISTS = eINSTANCE.getProtagonists();

    /**
     * The meta object literal for the '{@link Inno.CEOFactors <em>CEO Factors</em>}' enum.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see Inno.CEOFactors
     * @see Inno.impl.InnoPackageImpl#getCEOFactors()
     * @generated
     */
    EEnum CEO_FACTORS = eINSTANCE.getCEOFactors();

  }

} //InnoPackage
