/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package InnoM.util;

import InnoM.*;

import org.eclipse.emf.common.notify.Adapter;
import org.eclipse.emf.common.notify.Notifier;

import org.eclipse.emf.common.notify.impl.AdapterFactoryImpl;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * The <b>Adapter Factory</b> for the model.
 * It provides an adapter <code>createXXX</code> method for each class of the model.
 * <!-- end-user-doc -->
 * @see InnoM.InnoMPackage
 * @generated
 */
public class InnoMAdapterFactory extends AdapterFactoryImpl
{
  /**
   * The cached model package.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected static InnoMPackage modelPackage;

  /**
   * Creates an instance of the adapter factory.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public InnoMAdapterFactory()
  {
    if (modelPackage == null)
    {
      modelPackage = InnoMPackage.eINSTANCE;
    }
  }

  /**
   * Returns whether this factory is applicable for the type of the object.
   * <!-- begin-user-doc -->
   * This implementation returns <code>true</code> if the object is either the model's package or is an instance object of the model.
   * <!-- end-user-doc -->
   * @return whether this factory is applicable for the type of the object.
   * @generated
   */
  @Override
  public boolean isFactoryForType(Object object)
  {
    if (object == modelPackage)
    {
      return true;
    }
    if (object instanceof EObject)
    {
      return ((EObject)object).eClass().getEPackage() == modelPackage;
    }
    return false;
  }

  /**
   * The switch that delegates to the <code>createXXX</code> methods.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected InnoMSwitch<Adapter> modelSwitch =
    new InnoMSwitch<Adapter>()
    {
      @Override
      public Adapter caseINNO(INNO object)
      {
        return createINNOAdapter();
      }
      @Override
      public Adapter caseIsA(IsA object)
      {
        return createIsAAdapter();
      }
      @Override
      public Adapter caseFactor(Factor object)
      {
        return createFactorAdapter();
      }
      @Override
      public Adapter caseLeadership(Leadership object)
      {
        return createLeadershipAdapter();
      }
      @Override
      public Adapter caseProtagonist(Protagonist object)
      {
        return createProtagonistAdapter();
      }
      @Override
      public Adapter caseCEO(CEO object)
      {
        return createCEOAdapter();
      }
      @Override
      public Adapter caseCEOFactor(CEOFactor object)
      {
        return createCEOFactorAdapter();
      }
      @Override
      public Adapter defaultCase(EObject object)
      {
        return createEObjectAdapter();
      }
    };

  /**
   * Creates an adapter for the <code>target</code>.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param target the object to adapt.
   * @return the adapter for the <code>target</code>.
   * @generated
   */
  @Override
  public Adapter createAdapter(Notifier target)
  {
    return modelSwitch.doSwitch((EObject)target);
  }


  /**
   * Creates a new adapter for an object of class '{@link InnoM.INNO <em>INNO</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see InnoM.INNO
   * @generated
   */
  public Adapter createINNOAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link InnoM.IsA <em>Is A</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see InnoM.IsA
   * @generated
   */
  public Adapter createIsAAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link InnoM.Factor <em>Factor</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see InnoM.Factor
   * @generated
   */
  public Adapter createFactorAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link InnoM.Leadership <em>Leadership</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see InnoM.Leadership
   * @generated
   */
  public Adapter createLeadershipAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link InnoM.Protagonist <em>Protagonist</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see InnoM.Protagonist
   * @generated
   */
  public Adapter createProtagonistAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link InnoM.CEO <em>CEO</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see InnoM.CEO
   * @generated
   */
  public Adapter createCEOAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for an object of class '{@link InnoM.CEOFactor <em>CEO Factor</em>}'.
   * <!-- begin-user-doc -->
   * This default implementation returns null so that we can easily ignore cases;
   * it's useful to ignore a case when inheritance will catch all the cases anyway.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @see InnoM.CEOFactor
   * @generated
   */
  public Adapter createCEOFactorAdapter()
  {
    return null;
  }

  /**
   * Creates a new adapter for the default case.
   * <!-- begin-user-doc -->
   * This default implementation returns null.
   * <!-- end-user-doc -->
   * @return the new adapter.
   * @generated
   */
  public Adapter createEObjectAdapter()
  {
    return null;
  }

} //InnoMAdapterFactory
